routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\DepartmentController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function(){
	return redirect('login');
});

Route::get('/logout', function(){
	Auth::logout();
    return redirect('/login');
});

Route::group(['middleware' => ['auth']], function() {
    //dashboard
    Route::get('admin/dashboard', [DashboardController::class, 'index'])->name('admin.dashboard');
    //user
    Route::resource('admin/users', UserController::class);
    Route::post('admin/users/getUsers', [UserController::class,'getUsers'])->name('admin.users.getUsers');
    //department
    Route::resource('admin/departments', DepartmentController::class);
    Route::post('admin/users/getDepartments', [DepartmentController::class,'getDepartments'])->name('admin.users.getDepartments');
});
Auth::routes();

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'first_name',
        'last_name',
        'department_id',
        'email',
        'profile_image',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\User;
use App\Models\Department;
use Validator;
use Auth;
use DataTables;
use Config;
use Form;
use DB;
use Hash;
use App\Mail\NewUserMail;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin/users/index');    
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $department = Department::select('id','name')->get();
        return view('admin.users.create', compact('department'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        try{
            // dd($request->all());


       
        $validator = Validator::make($request->all(), [
            'first_name'       => 'required', 
            'last_name'        => 'required', 
            'email'         => 'required|email|unique:users,email', 
            'department_id'    => 'required',           
            'profile_image'    => 'image|max:2048',
            'password'          => 'required',
            'password_confirmation' => 'required|same:password'
        ]);     

        if ($validator->fails()) {
            return redirect()->back()
                        ->withErrors($validator)
                        ->withInput();
        }


      
            $data = $request->all();
           
            $data['password'] = Hash::make($request->password);
            $data['department_id'] = implode(',',$data['department_id']);
            $profile_image =  $request->file('profile_image');
              if($profile_image){
                $imageName = time().'.'.$profile_image->extension();  
                $profile_image->storeAs('images', $imageName);
                $data['profile_image'] = $imageName;
              }else{
                $data['profile_image'] = 'https://via.placeholder.com/150';
                
              }
            $user = User::create($data);
            $request->session()->flash('success','User added Successfully');
            // send mail
            $details = [
                'title' => 'Welcome Mail from Matellio',
                'body' => 'User has been created'
            ];
            \Mail::to($data['email'])->send(new NewUserMail($details));
            //
            return redirect()->to('admin/users');
         

        }catch (\Exception $e){
            return redirect()->back()->with('error',$e->getMessage());
        }
    
        
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

        try{
            $user = User::findOrFail($id);
            $department = Department::select('id','name')->get();
            return view('admin.users.create',compact('user','department'));
        }catch (\Exception $e){
            return redirect()->back()->with('error',$e->getMessage());
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        try{
        $validator = Validator::make($request->all(), [
            'first_name'       => 'required', 
            'last_name'        => 'required', 
            'email'         => 'required|email|unique:users,email,'.$id, 
            'department_id'    => 'required',           
            'profile_image'    => 'image|max:2048',
            'password'          => 'nullable',
            'password_confirmation' => 'nullable|same:password'
        ]);     

        if ($validator->fails()) {
            return redirect()->back()
                        ->withErrors($validator)
                        ->withInput();
        }


        $user = User::findOrFail($id);
            $data = $request->all();
            if (isset($data['password']) && !empty($data['password'])) {
                $data['password'] = Hash::make($request->password);
            }else{
                unset($data['password']);
            }
            $data['department_id'] = implode(',',$data['department_id']);
            $profile_image =  $request->file('profile_image');
              if($profile_image){
                $imageName = time().'.'.$profile_image->extension();  
                $profile_image->storeAs('images', $imageName);
                $data['profile_image'] = $imageName;
                if ($user->profile_image!='' && \Storage::exists('images/'.$user->profile_image)) {
                    \Storage::delete('images/'.$user->profile_image);
                }
                $data['profile_image'] = $imageName;
              }else{
                $data['profile_image'] = 'https://via.placeholder.com/150';
                
              }
            $user->update($data);
            $request->session()->flash('success','User updated Successfully');
            return redirect()->to('admin/users');

        }catch (\Exception $e){
            return redirect()->back()->with('error',$e->getMessage());
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        try{ 
            $user = User::findOrFail($id);
            $user->delete();
            session()->flash('danger','User deleted successfully');
            return redirect()->to('admin/users');
        }catch (\Exception $e){
            return redirect()->back()->with('error',$e->getMessage());
        }
        }

     
    public function getUsers(Request $request){
        $users = User::select([\DB::raw(with(new User)->getTable().'.*')]);
      return DataTables::of($users)
          ->editColumn('created_at', function($user){
              return date('Y-m-d', strtotime($user->created_at));
          })            
          ->addColumn('first_name', function($user){
              return $user->first_name;
          })
          ->addColumn('last_name', function($user){
            return $user->last_name;
        })
          ->addColumn('email', function($user){
              return $user->email;
          })
          ->editColumn('department_id', function ($user) {
            return $user->department_id;
          })
          ->addColumn('action', function ($user) {
              return
                  // edit
                  '<a href="'.route('users.edit',[$user->id]).'" class="btn btn-success btn-circle btn-sm"><i class="fas fa-edit"></i></a> '.
                  // Delete
                    Form::open(array(
                                'style' => 'display: inline-block;',
                                'method' => 'DELETE',
                                'onsubmit'=>"return confirm('Do you really want to delete?')",
                                'route' => ['users.destroy', $user->id])).
                    ' <button type="submit" class="btn btn-danger btn-circle btn-sm"><i class="fas fa-trash"></i></button>'.
                    Form::close();
          })
          ->rawColumns(['action'])
          ->make(true);
  }
}

resources/views/admin/users/create.blade.php
@extends('admin.layouts.valex_app')
@section('styles')
<link href="{{asset('template/valex-theme/plugins/select2/css/select2.min.css') }}" rel="stylesheet">
@endsection
@section('content')
<div class="container">
    <div class="breadcrumb-header justify-content-between">
      <div class="left-content">
          <div>
            <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Users</h2>
          </div>
      </div>
    </div>
    <div class="row row-sm">
        <div class="col-xl-12">
            <div class="card">
            {!! Form::open(['method' => 'POST','files'=>true,'url' => isset($user->id)?route('users.update',[$user->id]):route('users.store'),'class' => 'form-horizontal','id' => 'frmUser']) !!}
                @csrf
                @if(isset($user->id))
                @method('PUT')
                @endif
                <div class="card-header py-3 cstm_hdr">
                    <h6 class="m-0 font-weight-bold text-primary">Add User</h6>
                </div>
                <div class="card-body">
                    <div class="form-group @error('first_name') has-error @enderror">
                        <label class="col-md-3 control-label" for="first_name">First name <span style="color:red">*</span></label>
                         <div class="col-md-6">
                        {!! Form::text('first_name', old('first_name', isset($user->first_name)? $user->first_name :''), ['class' => 'form-control', 'placeholder' => 'First name']) !!}
                        @error('first_name')<small class="help-block">{{ $message }}</small> @enderror
                        </div>
                    </div>

                    <div class="form-group @error('last_name') has-error @enderror">
                        <label class="col-md-3 control-label" for="last_name">Last name <span style="color:red">*</span></label>
                         <div class="col-md-6">
                            {!! Form::text('last_name', old('last_name', isset($user->last_name)? $user->last_name :''), ['class' => 'form-control', 'placeholder' => 'Last name']) !!}
                            @error('last_name')<small class="help-block">{{ $message }}</small> @enderror

                        </div>
                    </div>

                    <div class="form-group @error('email') has-error @enderror">
                        <label class="col-md-3 control-label" for="email">Email <span style="color:red">*</span></label>
                        <div class="col-md-6">
                            {!! Form::text('email',old('email', isset($user->email)? $user->email :''), ['class' => 'form-control autoFillOff', 'placeholder' => 'Email']) !!}
                            @error('email')<small class="help-block">{{ $message }}</small>@enderror
                        </div>
                    </div>
                    <div class="form-group @error('department_id') has-error  @enderror">
                        <label class="col-md-3 control-label" for="department_id">Department <span style="color:red">*</span></label>
                        <div class="col-md-6">
							<select class="select2 select2-multiple form-control" name="department_id[]" id="department_id" multiple="multiple">
								<option value="">-- Select Department --</option>
									@foreach ($department as $departments)
								<option value="{{ $departments->id }}" @if(isset($user)) @foreach(explode(',', $user->department_id) as $dep){{$dep == $departments->id ? 'selected': ''}}   @endforeach @endif>{{ $departments->name }}</option>
									@endforeach
							</select>
                
                            @error('department_id')<small class="help-block">{{ $message }}</small>@enderror
                        </div>
                    </div>
                    <div class="form-group @error('password') has-error  @enderror">
                        <label class="col-md-3 control-label" for="password">Password <span style="color:red">*</span></label>
                        <div class="col-md-6">
                            <input type="password" name="password" class="form-control autoFillOff" placeholder="New Password" id="password">
                            @error('password')<small class="help-block">{{ $message }}</small>@enderror
                        </div>
                    </div>
                    <div class="form-group @error('password_confirmation') has-error  @enderror">
                        <label class="col-md-3 control-label" for="password_confirmation">Confirm Password <span style="color:red">*</span></label>
                        <div class="col-md-6">
                            <input type="password" name="password_confirmation" class="form-control autoFillOff" placeholder="Confirm Password" >
                            @error('password_confirmation')<small class="help-block">{{ $message }}</small>@enderror
                        </div>
                    </div>
                    <div class="form-group @error('profile_image') has-error  @enderror">                    
                        <label class="col-md-3 control-label" for="title">Profile image </label>
                        <div class="col-md-6">
                             <input type="file" name="profile_image" accept="image/*" id="profile_image">
                             <img src="{{ isset($user->prifile_image)? $user->profile_image : '' }}" width="50"> 
                            @error('profile_image')<small class="help-block">{{ $message }}</small>@enderror
                        </div>
                    </div>
                </div>  
                <div class="card-footer">
                    <button type="submit" class="btn btn-responsive btn-primary">{{ __('Submit') }}</button>
                    <a href="{{url('admin/users')}}"  class="btn btn-responsive btn-secondary">{{ __('Cancel') }}</a>
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>        
</div>
<!-- /.container-fluid -->
@endsection
@section('scripts')
<script src="{{ asset('template/valex-theme/plugins/select2/js/select2.min.js') }}"></script>

<script type="text/javascript">
jQuery(document).ready(function(){
    $('.select2').select2({
            placeholder: 'Choose',
            searchInputPlaceholder: 'Search'
    });
    
        
});
</script>
@endsection

resources/views/admin/users/index.blade.php
@extends('admin.layouts.valex_app')
@section('styles')
<link href="{{asset('template/valex-theme/plugins/datatable/css/dataTables.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/buttons.bootstrap4.min.css')}}" rel="stylesheet">
<link href="{{asset('template/valex-theme/plugins/datatable/css/jquery.dataTables.min.css')}}" rel="stylesheet">
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.dataTables.min.css')}}" rel="stylesheet">
@endsection
@section('content')
<!-- Begin Page Content -->
<div class="container">
  <div class="breadcrumb-header justify-content-between">
      <div class="left-content">
          <div>
            <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Users</h2>
          </div>
      </div>
  </div>
  <div class="row row-sm">
    <div class="col-xl-12">
      <div class="card">
        <div class="card-header py-3 cstm_hdr">
            <h6 class="m-0 font-weight-bold text-primary">Users List</h6>
            <a href="{{route('users.create')}}" class="btn btn-sm btn-icon-split float-right btn-outline-warning">
                <span class="icon text-white-50">
                  <i class="fas fa-plus"></i>
                </span>
                <span class="text">Add User</span>
            </a>
        </div>
        <div class="card-body">
            <div class="table-responsive">
                <table class="table table-bordered" width="100%" cellspacing="0" id="users">
                    <thead>
                        <tr>
                          <th>First name</th>
                          <th>Last name</th>
                          <th>Email</th>                         
                          <th>Registration Date</th>
                          <th>Action</th>                          
                        </tr>
                    </thead>
                    <tfoot>
                        <tr>
                        <th>First name</th>
                          <th>Last name</th>
                          <th>Email</th>                         
                          <th>Registration Date</th>
                          <th>Action</th>                        
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div>
      </div>
    </div>
  </div>
</div>    
<!-- /.container-fluid -->
@endsection
@section('scripts')
<!-- Page level plugins -->
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.bootstrap4.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.bootstrap4.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/vfs_fonts.js') }}"></script>
<!-- export btn -->
<script type="text/javascript">
jQuery(document).ready(function(){
    getUsers();
});

function getUsers(){
  var role_id = jQuery('#frmFilter [name=role_id]').val();
  jQuery('#users').dataTable().fnDestroy();
  jQuery('#users tbody').empty();
  jQuery('#users').DataTable({
      processing: true,
      serverSide: true,
      iDisplayLength:50,
      ajax: {
          url: '{{ route('admin.users.getUsers') }}',
          method: 'POST',
      },
      lengthMenu: [
          [10, 25, 50, 100,1000, -1],
          [10, 25, 50,100,1000,"All"]
      ],

      columns: [
          {data: 'first_name', name: 'first_name'},
          {data: 'last_name', name: 'last_name'},
          {data: 'email', name: 'email'},    
          {data: 'created_at', name: 'created_at'},
          {data: 'action', name: 'action', orderable: false, searchable: false, "width": "10%"},            
      ],           
      order: [[0, 'desc']],
      language: {
            searchPlaceholder: 'Search...',
            sSearch: '',
            lengthMenu: '_MENU_',
      },        
    });
}
</script>
@endsection